(if (not (defined? 'db-open))
    (begin
	(dynamic-call "scm_init_db4_3" (dynamic-link "/usr/lib/guile/libguiledb4.3.so"))))

(define-module (database berkeley))

(define (data->string data)
    (with-output-to-string
	(lambda ()
	    (write data))))

(define (string->data string)
    (with-input-from-string
	string
	(lambda ()
	    (read))))

(define-public (db-put handle key data)
    (let (
	    (k (data->string key))
	    (d (data->string data)))
	(db-put-text handle k d)))

(define-public (db-get handle key)
    (let (
	    (k (data->string key)))
	(string->data (db-get-text k))))

(define-public (db-del handle key)
    (let (
	    (k (data->string key)))
	(db-del-text k)))

